package reductionRules.path;

import java.util.ArrayList;

import main.Node;

public class PathRedLPYSet {
//	public Node L;//leaves as neighbours
	public Node[] P2s;
	public Node Y;//Y-Graphs
	Node n;
	
	public PathRedLPYSet(Node n) {
		this.n = n;
		ArrayList<Node> p2s = new ArrayList<Node>();
		for(Node neighbour : n.nonCyclicNeighbours)
		{
			//if(neighbour.getNeighbourCount() == 1)
			//	L = neighbour;
			if(neighbour.getNeighbourCount() == 2)
				p2s.add(neighbour);
			else 
				Y = neighbour;
		}
	}
	
	public static boolean hasLeaf(Node n)
	{
		return getLeaf(n) != null;
	}
	
	public static Node getLeaf(Node n)
	{
		for(Node neighbour : n.nonCyclicNeighbours)
		{
			if(neighbour.getNeighbourCount() == 1)
				return neighbour;
		}
		return null;
	}
	
	public static boolean hasYGraph(Node n)
	{
		return getYGraph(n) != null;
	}
	
	public static Node getP2(Node n)
	{
		for(Node neighbour : n.nonCyclicNeighbours)
		{
			if(neighbour.getNeighbourCount() == 2)
				return neighbour;
		}
		return null;
	}
	
	public static boolean hasP2(Node n)
	{
		return getP2(n) != null;
	}
	
	public static Node getYGraph(Node n)
	{
		for(Node neighbour : n.nonCyclicNeighbours)
		{
			if(neighbour.getNeighbourCount() > 2)
				return neighbour;
		}
		return null;
	}
	
	public static int getP2Count(Node n)
	{
		int count = 0;
		for(Node neighbour : n.nonCyclicNeighbours)
		{
			if(neighbour.getNeighbourCount() == 2)
				count++;
		}
		return count;
	}
}
