package result;

import java.util.HashSet;

import Utils.Tuple;

public class DeletedEdgeEntry extends ResultListEntry {
	String n1Name;
	String n2Name;
	public DeletedEdgeEntry(boolean addedByDataReduction, String n1Name, String n2Name) {
		super(addedByDataReduction);
		this.n1Name = n1Name;
		this.n2Name = n2Name;
	}
	@Override
	public void addDeletedEdges(HashSet<Tuple<String, String>> returnVal) {
		returnVal.add(new Tuple<String, String>(n1Name, n2Name));
	}
	
	@Override
	public int getSize() {
		return 1;
	}
}
