package solving;

import main.Graph;
import main.Node;
import main.SolvingState;
import main.Start;
import visualization.GraphChanger;
import visualization.GraphComponent;
import visualization.BranchingTree.BranchTreeViewing;

@Deprecated
public abstract class BranchSolverStep_old extends GraphChanger
{
	public abstract int start(Graph g, int k);
	
	private BranchSolverStep_old nextStep;
	public BranchSolverStep_old(BranchSolverStep_old nextStep) 
	{
		this.nextStep = nextStep;
	}
	
	protected int goToNextStep(Graph g, int k)
	{
		if(nextStep == null)
			return k;
		else return nextStep.start(g, k);
	}
	
	protected class Edge implements GraphComponent{
		Node n1, n2;
		public Edge(Node n1, Node n2) {
			this.n1 = n1;
			this.n2 = n2;
		}
		@Override
		public boolean contains(Node n) {
			return n1==n || n2==n;
		}
	}
	
	public SolvingState getNormalState()
	{
		return SolvingState.BRANCHING;
	}
	
	@Override
	protected void OnBeforeChange(Graph g, GraphComponent d)
	{
		super.OnBeforeChange(g, d);
		if(Start.useBranchTreeVisualization){
			BranchTreeViewing.onNewBranch(d, this);
		}
	}
	
	protected void onBranchReturn()
	{
		if(Start.useBranchTreeVisualization){
			BranchTreeViewing.onBranchReturn();
		}
	}
}
