package solving.oldSolver.steps;

import java.util.LinkedList;

import reductionRules.Reduction;
import solving.BranchSolverStep_old;

import Utils.ConnCompIterator;
import Utils.GraphUtils;
import Utils.Tuple;
import main.Graph;
import main.Node;

public class BranchFinisher extends BranchSolverStep_old {

	public BranchFinisher() {
		super(null);
	}

	@Override
	public int start(Graph g, int k) {
		if(g.nodes.isEmpty())
			return 0;

		LinkedList<Tuple<String, String>> resultList = new LinkedList<Tuple<String,String>>();
		//TODO add resultList to returnvalue
		
		ConnCompIterator compIterator = new ConnCompIterator(g);
		while(compIterator.hasNext())
		{
			Node leaf = GraphUtils.findLeaf(compIterator.next());
			//k -= Reduction.applyTreeReductionRules(g, leaf, null, resultList);TODO FIXME
			if(k < 0)
				return -1;
		}
		Reduction.removeCaterpillars(g);
		if(!g.nodes.isEmpty())
			throw new IllegalStateException("Error: Graph should be empty now, but is not.");
		return k;
	}

	@Override
	public String getName() {
		return "Finished";
	}

}
