package visualization.BranchingTree;

import main.Start;
import solving.BranchSolverStep_old;
import visualization.GraphComponent;

public class BranchTreeViewing {

	static TreeViewFrame viewFrame;
	public static void onNewBranch(GraphComponent component, BranchSolverStep_old solverStep)
	{
		if(Start.useBranchTreeVisualization)
		{
			if(viewFrame==null)
			{
				viewFrame = new TreeViewFrame();
				viewFrame.setVisible(true);
			}
			viewFrame.onNewBranching(component, solverStep);
		}
	}
	public static void onBranchReturn()
	{
		if(Start.useBranchTreeVisualization)
			viewFrame.onBranchingReturned();
	}
}
