package GraphGenerator;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

public class MultiGen {
	public static void main(String[] args) {

		String dir = "D:/TU-Berlin/akt/instances/big";
		File d = new File(dir);
		if(!d.exists())
			d.mkdirs();
		for(int size = 30; size < 50; size+=1)
		{
			for(int count = 0; count < 10; count++)
			for(int addedEdges = 1; addedEdges < 10; addedEdges+=1)
			{
				File file = new File(d, "Graph"+count+"_n_"+numToDigitString(size, 3)+"_k_"+numToDigitString(addedEdges, 2)+".txt");
				try {
					BufferedWriter writer = new BufferedWriter(new FileWriter(file));
					Generator.generateGraph(writer, size, addedEdges);
					writer.close();

				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
	private static String numToDigitString(int num, int digits)
	{
		String s = num+"";
		while(s.length()<digits)
			s = "0"+s;
		return s;
	}
}
