package solving.circlesTree;

import main.Node;
import main.Path;

public class SimpleNode extends PathBasedCircleTreeNode 
{
	private Node node;

	public SimpleNode(Node node) 
	{
		this.node = node;
	}

	public Node getNode() 
	{
		return node;
	}

	@Override
	public boolean isComplete() 
	{
		return true;
	}
	
	@Override
	public void setComplete() {}//do nothing, this node is allways complete

	@Override
	public Node getFirstNode() {
		return getNode();
	}

	@Override
	public void addToPath(Path p){}//do nothing

	@Override
	public int getEdgesCount() {
		return 0;
	}
}
